steer
========

The steering classes of the FairRoot are stored here.
The `FairRun` class is the base of all data processors (`FairRunSim`, `FairRunAna`, `FairRunOnline`, `FairRunAnaProof`).

<!---
* `FairRunSim` manages the Monte Carlo simulations
* `FairRunAna` manages the analysis/data processing
* `FairRunOnline` to analyze data from `FairSource`
* `FairRunAnaProof` manages the data analysis on the *PROOF* (Parallel ROOT Facility for parallel data processing on the event level)
-->

The `FairRootManager` takes care for the input-output communication in the run classes. The `FairTask` is the base class for the analysis code.

The radiation length studies may be performed using the `FairRad...` classes.

In order to visualize the simulated particle trajectories, one should SetStoreTraj(kTRUE) of the `FairRunSim` object. It is possible to implement cuts via the singleton `FairTrajFilter` class.

The mother classes for the time based simulation are also located here (`FairWriteoutBuffer`, `FairRingSorter`, `FairRingSorterTask`). One finds here also the `FairTSBufferFunctional` providing realistic access to the time based simulated data for further analysis.
