# Searching for TDAQ installation
# Once done this will define
#  TDAQ_FOUND - system has TDAQ framework
#  TDAQ_INCLUDE_PATH - the TDAQ include directory
#  TDAQ_LIBRARY_PATH - the TDAQ library directory

if (NOT TDAQ_SW)
  FIND_PATH(TDAQ_SW NAMES ipc_root.ref PATHS
    /tdaq/tdaq_sw
    NO_DEFAULT_PATH
  )
endif (NOT TDAQ_SW)

if (NOT TDAQ_LIBRARY_PATH)
  FIND_PATH(TDAQ_EMON_LIBRARY_DIR NAMES libemon.so PATHS
    ${TDAQ_SW_DIR}/emon/lib
    /tdaq/tdaq_sw/emon/lib
    NO_DEFAULT_PATH
  )
  FIND_PATH(TDAQ_IS_LIBRARY_DIR NAMES libXm.so PATHS
    ${TDAQ_SW_DIR}/is/lib
    /tdaq/tdaq_sw/is/lib
    NO_DEFAULT_PATH
  )

  if (TDAQ_EMON_LIBRARY_DIR AND TDAQ_IS_LIBRARY_DIR)
    set(TDAQ_LIBRARY_PATH ${TDAQ_EMON_LIBRARY_DIR} ${TDAQ_IS_LIBRARY_DIR})
  endif (TDAQ_EMON_LIBRARY_DIR AND TDAQ_IS_LIBRARY_DIR)
endif (NOT TDAQ_LIBRARY_PATH)

FIND_PATH(TDAQ_SW_INCLUDE_DIR NAMES ers/ers.h PATHS
  ${TDAQ_SW_DIR}/include
  /tdaq/tdaq_sw/include
  NO_DEFAULT_PATH
)
FIND_PATH(TDAQ_EMON_INCLUDE_DIR NAMES emon/emon.hh PATHS
  ${TDAQ_SW_DIR}/emon/include
  /tdaq/tdaq_sw/emon/include
  NO_DEFAULT_PATH
)
FIND_PATH(TDAQ_IS_INCLUDE_DIR NAMES is/is.hh PATHS
  ${TDAQ_SW_DIR}/is/include
  /tdaq/tdaq_sw/is/include
  NO_DEFAULT_PATH
)

if (TDAQ_SW_INCLUDE_DIR AND TDAQ_EMON_INCLUDE_DIR AND TDAQ_IS_INCLUDE_DIR)
  set(TDAQ_INCLUDE_PATH ${TDAQ_SW_INCLUDE_DIR} ${TDAQ_EMON_INCLUDE_DIR} ${TDAQ_IS_INCLUDE_DIR})
endif (TDAQ_SW_INCLUDE_DIR AND TDAQ_EMON_INCLUDE_DIR AND TDAQ_IS_INCLUDE_DIR)


if (TDAQ_SW AND TDAQ_INCLUDE_PATH AND TDAQ_LIBRARY_PATH)
  set(TDAQ_FOUND TRUE)
  
  if (NOT TDAQ_FIND_QUIETLY)
    MESSAGE(STATUS "Looking for ATLAS TDAQ... found ${TDAQ_SW}")
    SET(LD_LIBRARY_PATH ${LD_LIBRARY_PATH} ${TDAQ_LIBRARY_PATH})
  endif (NOT TDAQ_FIND_QUIETLY)
else (TDAQ_SW AND TDAQ_INCLUDE_PATH AND TDAQ_LIBRARY_PATH)
  if (TDAQ_FIND_REQUIRED)
    message(FATAL_ERROR "Looking for ATLAS TDAQ... - Not found")
  endif (TDAQ_FIND_REQUIRED)
endif (TDAQ_SW AND TDAQ_INCLUDE_PATH AND TDAQ_LIBRARY_PATH)
